
#ifndef	_GETMAIL_H
#define _GETMAIL_H


#if HAVE_REGEX_H
  #include <regex.h>
#else
  #include "regex.h"
#endif


#define SPAM_IGNORE	0
#define	SPAM_DELE	1
#define	SPAM_KEEP	2
#define SPAM_ASK	3


#define SA_YES_DELE	"true-delete"
#define SA_YES_KEEP	"true-keep"
#define SA_YES_ASK	"true_ask"
#define SA_NO_DELE	"false_delete"
#define	SA_NO_KEEP	"false_keep"
#define SA_NO_ASK	"false_ask"

#define	SK_ID		"id:"
#define	SK_SIZE		"quota:"
#define	SK_FROM		"from:"
#define	SK_SUBJECT	"subject:"
#define	SK_ACTION	"action:"

#define	SLPOOL	256	/* pool for Slnk structure */
#define PATHMAX 256	/* maximem length of path */ 

typedef struct	_Spam	{

	struct	_Spam	*next;		

	int	id;		/* 0 is general identity */
	int	quota;		/* message size quota */
	char	*from;
	char	*subject;
	
	int	logic;		/* 0: normal logic, 1: minus logic */
	int	action;		/* procession of matcher */

	/* private structure area */
	
	regex_t	*from_reg;
	regex_t *sub_reg;
	
	int	ireg;		/* index of "preg" buffer */
	regex_t preg[2];	/* by now for "from" and "subject" */
	
} Spam;


typedef	struct	{

	Spam	*sc;
	void	*next;
} Slnk;


#define GP_POP3		1
#define GP_APOP		2

#define GMAIL_CHECK     1
#define GMAIL_FETCH     2
#define GMAIL_LIST      4
#define GMAIL_DELE      8

#define	TOP_SMART	0
#define TOP_ALL		1
#define TOP_BRIEF	2


/* when operating on remote, this structure owns high priority that GMAIL */

struct	gm_att	{

	int	topl;		/* lines of mailbody for TOP check */
	int	tops;		/* style of mailhead, 0 smart, 1 all */
	//int	quota;		/* maximum mail size when retrieving it */
	int	delay;		/* a short delay after logging in */
	int	cols;		/* current columns in the screen */
	
	/* in below come from command line */
	
	int	*cp_set;	/* current processing set */
	char	*mbox;		/* message box from command line */
	int     act;		/* download action from command line */
	char	*user;
	char	*pass;
	char	*defbox;	/* default mailbox if no mailbox specified */

	char	*hdmsk[HMMAX];
	char	*hdbuf;		/* point to headmask buffer inside 'buf' */
	char	buf[1];
};

	
typedef	struct  _GMAIL	{
	
	/* read only part, looks on as attribution of POP3 connection 
	   Note that if there are same entries between this structure 
	   and attribution structure, use the attribution entries.
	   They are mbox, act, user and pass.  */
	
	struct	_GMAIL	*next;	
	char    *host;	
	char    *lid;		/* login id */
	char    *pass;		/* user's password */
	char    *mbox;		/* mailbox for saving retrieved mails */
	int     act;		/* operation in this session */
	int	protl;
	Slnk	*slnk;		/* spam filter chain */
	int	topspam;	/* set if anti-spam need TOP command */
	struct  gm_att  *attr;
	
	/* working varible */
	
	int	socket;		/* put these here for close-convenient */
	FILE	*fp;		/*   against signal */
	int	*mlist;		/* structure list of mails */
	char	*time_stamp;
	int	msgs;		/* number of messages */
	int	volm;		/* volumn of messages */
	int	distop;		/* 1: disable all TOP commmand relative */
	char	buf[1];
	
} GMAIL;

#include "mhead.h"

int  gmail_main(GMAIL *gm, Head *head);
int  gmail_single(GMAIL *gm, Head *head);
GMAIL *gmail_open();
GMAIL *gmail_cmdarg(char *arg);
void gmail_close();
void gmail_host_list();
int  gmail_set_action(char *s);

Spam *spam_match_chain(Slnk *sl, Head *, int);
Spam *spam_match_size(Slnk *sl, int size);
int  spam_need_top(Slnk *sl);
Spam *spam_queue_open();
void spam_queue_free();

#ifdef	DEBUG
int  spam_test(char *file);
#endif

/* see pop3.h */

int  pop3_main(GMAIL *gm, Head *head);


#endif

