
#ifndef	LIBSUPP_H
#define	LIBSUPP_H

#include <time.h>
#include "md5.h"
#include "pmalloc.h"
#include "socket.h"
#include "address.h"

#ifndef HAVE_REGEX_H
#include "regex.h"
#endif

/* see codec.c */

int  enbase64(char *sour, int n, char *dest);
int  debase64(char *sour, int n, char *dest);
int  debase64_str(char *sour, char *buf);
int  enbase64_file(FILE *fin, FILE *fout, int glen);
int  debase64_file(FILE *fin, FILE *fout);
char *debase64_bndry(FILE *fin, FILE *fout, char *bndry, char *buf, int len);
int  enqp_str(unsigned char *sour, int n, char *buf);
int  deqp_str(char *sour, char *buf);
int  enqp_file(FILE *fin, FILE *fout);
int  deqp_file(FILE *fin, FILE *fout);
char *deqp_bndry(FILE *fin, FILE *fout, char *bndry, char *buf, int len);
int  enhz_str(unsigned char *sour, int n, char *buf);
int  dehz_str(unsigned char *sour, char *buf);
int  enhz_file(FILE *fin, FILE *fout);
int  dehz_file(FILE *fin, FILE *fout);
int  atohex(char *s);


/* see debug.c */

int  log_open(char *, int);
void log_close();
int  logPrintf(int lvl, char *fmt, ... );
int  dbgPrintf(char *fmt, ... );
int  conPrintf(char *fmt, ...);
int  errPrintf(char *fmt, ...);

/* see fixtoken.c */

int fixtoken(char *sour, char **idx, int ids, char *delim);
int ziptoken(char *sour, char **idx, int ids, char *delim);

/* see mkargs.c */

int mkargs(char *sstr, char *argvs[], int argcs);

/* see mktmpdir.c */

char *mktmpdir(char *template);

/* see misc.c */

#ifndef	HAVE_STRCASECMP
int strcasecmp(char *sour, char *dest);
int strncasecmp(char *sour, char *dest, int leng);
#endif

char *dup_str(char *s);
int  dup_stream(FILE *fin, FILE *fout);
int  isblankline(char *buf);
int  isdigitword(char *buf);
int  isheadline(char *buf);
char *skip_space(char *sour);
char *line_refine(char *s, int commt);
void compress_space(char *sour);
time_t filedate(char *filename, int *msize);
char *get_user();
char *get_home();
char *get_hostname();
int  ismailstart(char *buf);
int  atonum(char *s);
int  isinset(int id, int *set);
char *timenow();
char *fullpath(char *sour, char *dest);

/* see parse.c */

int  rc_open(char *s);
void rc_close();
char *rc_check(char *key);
char *rc_check_next();
void rc_comment(int ch);
	
/* see progress.c */

//void prog_init(int expect, int range);
//void prog_do(int d_in);
//void prog_end();
extern void (*prog_init)(int exp, int range);
extern void (*prog_do)(int d_in);
extern void (*prog_end)();
void progress_init(int id);

#ifdef	DEBUG
void progress_test();
#endif

/* see ssprintf.c */

void ssp_def(int ch);
int ssprintf(char *buf, int n, char *fmt, ...);
int siprintf(char *buf, int n, char *fmt, ...);

#endif

