
#ifndef		_PMALLOC_H
#define		_PMALLOC_H


typedef	struct	_PMAL	{

	struct	_PMAL	*prev;	/* double chain list */
	struct	_PMAL	*next;
	struct	_PMAL	*sub;	/* sub-object single chain list */
	
	int	items;		/* number of maximem items, (as const) */
	int	space;		/* size of required memory, (as const) */
	
	int	used;		/* have used space */
	
	char	**item;		/* item array */
	void	*cur;		/* to current available space */
	char	mem[1];		/* actual allocated space */
	
} PMAL;

void pm_destruct();
PMAL *pm_handler(int items, int size);
void pm_close(PMAL *pm);
void *pm_alloc(PMAL *pm, int size);
void pm_free(PMAL *pm);
char *pm_dup_str(PMAL *pm, char *str);

extern int pm_errno;

#define	PM_SUCCESS	0
#define	PM_NOMEM	1  /* out of system memory, error from malloc() */
#define	PM_LBLOCK	2  /* too large block required over than PMAL space */
#define	PM_OUTITEM	3  /* out of item space */
#define PM_OUTMEM	4  /* out of PMAL space */
#define	PM_CONTINU	5  /* successed but continuous to next PMAL */
#define PM_NULLOP	6  /* null operatioon */

#endif

