
#ifndef	_MHEAD_H
#define _MHEAD_H


#include "pmalloc.h"


#define	HDPAGE		4096	/* for PMAL buffer */
#define HDIDX		64

struct	head_chain	{
	char	*str;
	void	*next;
};

typedef struct	{

	int	len;		  /* length of the entire head line */
	int	rm;		  /* removed marking */
	char	*key;		  /* duplication of the head key */
	char	*body;		  /* head body, no key started with. Note */
				  /* it's just a shortcut to body in headin */
	char	*headin;	  /* the first part of this head */
	struct	head_chain  *hc;  /* the remain parts of this head */
	void	*next;
	
} HLin;

typedef	struct	{

	int	len;	/* length of entire head part */
	int	num;	/* number of head title */
	char	*fmsp;	/* the copy of FromSps line */
	HLin	*hlin;	/* start of head line chain */
	HLin	*last;	/* last item in the head line chain */
	PMAL	*pm;
	void	*this;	/* point to current Head object itself */

	char	*skey;	/* use fro searching next head title */
	HLin	*scur;
	
} Head;

Head *head_register(int page, int idx);
void head_destruct(Head *hdo);
char *head_loading(Head *hdo, char *s);
void head_clean(Head *hdo);
int  head_to_cache(Head *hdo, FILE *fin, char *buf, int len);
int  head_of_file(Head *hdo, FILE *fin, char *buf, int len);
char *head_append(Head *hdo, char *head);
void head_remove_first(Head *hdo, char *key);
void head_remove_all(Head *hdo, char *key);
void head_mask(Head *hdo, char *mask, int rm);
HLin *head_check(Head *hdo, char *key);
HLin *head_check_next(Head *hdo);
char *head_fetch(HLin *h);
char *head_fetch_body(HLin *h);
HLin *head_exist(Head *hdo, char *head);
void head_dump(Head *hdo, FILE *fout, int fmsp);
char *head_index(char *headline, char *buf, int len);
int  head_cmp(char *s, char *d);

#endif

